# #########################################################################
# Copyright (C) 2011 Marcelo Hashimoto
#
# This file is part of Polly.
#
# Polly is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Polly is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Polly. If not, see <http://www.gnu.org/licenses/>.
# #########################################################################



import gtk as Gtk



COMMENTS = u'Manage multiple columns of multiple Twitter accounts.'


LICENSE = u'''Polly is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Polly is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Polly. If not, see <http://www.gnu.org/licenses/>.'''


AUTHORS = [b'Marcelo Hashimoto <conscioususer@gmail.com>']


ARTISTS = [b'Joern Konopka <cldx3000@gmail.com>',
           b'Georgi Karavasilev <motorslav@gmail.com>',
           b'Marcelo Hashimoto <conscioususer@gmail.com>',
           b'Chris Druif <cyber.druif@gmail.com>']



class Runner(object):
    def __init__(self, program_name, version, copyright, website, logo_icon_name):
        self.program_name = program_name

        self.version = version

        self.copyright = copyright

        self.website = website

        self.logo_icon_name = logo_icon_name


    def run(self, toplevel):
        Gtk.show_about_dialog(toplevel,
                              program_name=self.program_name,
                              version=self.version,
                              copyright=self.copyright,
                              comments=COMMENTS,
                              license=LICENSE,
                              wrap_license=False,
                              website=self.website,
                              authors=AUTHORS,
                              artists=ARTISTS,
                              logo_icon_name=self.logo_icon_name)
