# #########################################################################
# Copyright (C) 2011 Marcelo Hashimoto
#
# This file is part of Polly.
#
# Polly is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Polly is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Polly. If not, see <http://www.gnu.org/licenses/>.
# #########################################################################



from gtk import gdk as Gdk


from polly.gui.twitter.lead.user import User

from polly.gui.stream import PAGE_SIZE

from polly.gui.stream.leads import Leads



class Suggestions(Leads):
    def _get_processed_dataset(self):
        if self.resetted:
            self.resetted = False

            self.user_dataset = None

        if self.user_dataset is None:
            self.user_dataset = self.account.backend.get_suggestion_dataset(self.parameter[0])

        index = self.page_number * PAGE_SIZE

        Gdk.threads_enter()

        self.previous_button.set_sensitive(self.page_number > 0)

        self.next_button.set_sensitive(index + PAGE_SIZE < len(self.user_dataset))

        Gdk.threads_leave()

        return self.user_dataset[index:(index + PAGE_SIZE)]


    def _build(self, data):
        return User(data, self, self.user_backend_cache, self.relationship_backend_cache, self.color_scheme, self.font_scheme, self.emblem_factory, self.button_factory, self.avatar_factory, self.status_bar, self.main_panel)


    def __init__(self, key, account, parameter, color_scheme, font_scheme, emblem_factory, button_factory, avatar_factory, status_bar, main_panel, manager):
        if not isinstance(parameter, list):
            raise TypeError

        if len(parameter) != 2:
            raise ValueError

        if not isinstance(parameter[0], unicode):
            raise TypeError

        if not isinstance(parameter[1], unicode):
            raise TypeError

        super(Suggestions, self).__init__(key, account, parameter, color_scheme, font_scheme, emblem_factory, button_factory, avatar_factory, status_bar, main_panel, manager)

        self.user_dataset = None

        self.relationship_backend_cache = account.backend.relationship_backend_cache

        markup = u'Suggestions: {}'.format(self.parameter[1])

        self.label.set_markup(markup)
        self.label.set_tooltip_markup(markup)
