# #########################################################################
# Copyright (C) 2011 Marcelo Hashimoto
#
# This file is part of Polly.
#
# Polly is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Polly is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Polly. If not, see <http://www.gnu.org/licenses/>.
# #########################################################################



from gtk import gdk as Gdk


from polly.twitter.account import Error

from polly.gui import DEFAULT_BORDER

from polly.gui.stream import Stream



class Topics(Stream):
    def _build_buttons(self):
        pass


    def _isolate_buttons(self):
        pass


    def _update(self):
        try:
            dataset = self._get_dataset()
        except Error as error:
            self.status_bar.popup(error.message)
        else:
            Gdk.threads_enter()

            topics = self.inner_box.get_children()

            for topic in topics:
                self.inner_box.remove(topic)

            Gdk.threads_leave()

            for data in dataset:
                topic = self._build(data)

                Gdk.threads_enter()

                self.inner_box.pack_start(topic, False, False, 0)

                Gdk.threads_leave()

            for topic in topics:
                topic.isolate()

                Gdk.threads_enter()

                topic.destroy()

                Gdk.threads_leave()


    def __init__(self, key, account, parameter, color_scheme, font_scheme, button_factory, status_bar, manager):
        super(Topics, self).__init__(key, account, parameter, True, color_scheme, font_scheme, button_factory, status_bar, manager)

        self.inner_box.set_border_width(2 * DEFAULT_BORDER)
        self.inner_box.set_spacing(2 * DEFAULT_BORDER)


    def isolate(self):
        Gdk.threads_enter()

        topics = self.inner_box.get_children()

        Gdk.threads_leave()

        for topic in topics:
            topic.isolate()

        super(Topics, self).isolate()



import categories, trends
