# #########################################################################
# Copyright (C) 2011 Marcelo Hashimoto
#
# This file is part of Polly.
#
# Polly is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Polly is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Polly. If not, see <http://www.gnu.org/licenses/>.
# #########################################################################



from polly.gui.twitter.topic.category import Category

from polly.gui.stream.topics import Topics



NAME = u'Suggestion categories'



class Categories(Topics):
    def _get_dataset(self):
        return self.account.backend.get_category_dataset()


    def _build(self, data):
        return Category(data, self, self.color_scheme)


    def __init__(self, key, account, parameter, color_scheme, font_scheme, button_factory, status_bar, manager):
        super(Categories, self).__init__(key, account, parameter, color_scheme, font_scheme, button_factory, status_bar, manager)

        self.label.set_text(NAME)
        self.label.set_tooltip_text(NAME)
