# #########################################################################
# Copyright (C) 2011 Marcelo Hashimoto
#
# This file is part of Polly.
#
# Polly is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Polly is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Polly. If not, see <http://www.gnu.org/licenses/>.
# #########################################################################



import gtk as Gtk

from gtk import gdk as Gdk


from polly.gui import DEFAULT_BORDER

from polly.gui.twitter import Link



class Topic(Link):
#    def __del__(self):
#        print u'DEBUG: TOPIC DELETED'
    def _on_child_button_press_event(self, widget, event):
        self.child_pressed = True

        return False


    def _on_child_focus_in_event(self, widget, event):
        if self.child_pressed:
            self.child_pressed = False
        else:
            toplevel = self.get_toplevel()

            if toplevel.focused:
                self.stream.popup_child(self, 2 * DEFAULT_BORDER)

        return False


    def _on_color_normal_fg_changed(self):
        Gdk.threads_enter()

        self.set_color(self.color_scheme.normal_fg)

        Gdk.threads_leave()


    def __init__(self, title, stream, color_scheme):
        self.stream = stream

        self.color_scheme = color_scheme

        Gdk.threads_enter()

        super(Topic, self).__init__(u'<big>\u2022  {}</big>', self._on_clicked)
        self.set_markup(title)

        self.box.connect(u'button-press-event', self._on_child_button_press_event)
        self.box.connect(u'focus-in-event', self._on_child_focus_in_event)

        Gdk.threads_leave()

        self.color_scheme.block_updates()

        self._on_color_normal_fg_changed()

        self.color_normal_fg_uid = self.color_scheme.normal_fg_notifier.connect(self._on_color_normal_fg_changed)

        self.color_scheme.allow_updates()

        self.child_pressed = False


    def isolate(self):
        self.color_scheme.block_updates()

        self.color_scheme.normal_fg_notifier.disconnect(self.color_normal_fg_uid)

        self.color_scheme.allow_updates()

        super(Topic, self).isolate()



import category, trend
