# #########################################################################
# Copyright (C) 2011 Marcelo Hashimoto
#
# This file is part of Polly.
#
# Polly is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Polly is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Polly. If not, see <http://www.gnu.org/licenses/>.
# #########################################################################



from polly import escape

from polly.twitter.topic.category import NICK_KEY, TITLE_KEY, SIZE_KEY

from polly.gui.twitter.topic import Topic



class Category(Topic):
    def _on_clicked(self):
        self.stream.manager.new_suggestions(self.stream.account, [self.nick, self.title], self.stream)


    def __init__(self, category_data, stream, color_scheme):
        self.nick = category_data[NICK_KEY]

        self.title = escape(category_data[TITLE_KEY])

        full_title = u'{} ({})'.format(self.title, category_data[SIZE_KEY])

        super(Category, self).__init__(full_title, stream, color_scheme)
