# #########################################################################
# Copyright (C) 2011 Marcelo Hashimoto
#
# This file is part of Polly.
#
# Polly is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Polly is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Polly. If not, see <http://www.gnu.org/licenses/>.
# #########################################################################



from urllib import unquote


from polly import ENCODING, escape

from polly.twitter.topic.trend import TITLE_KEY, QUERY_KEY

from polly.gui.twitter.topic import Topic



class Trend(Topic):
    def _on_clicked(self):
        self.stream.manager.new_results(self.stream.account, [self.query, False], self.stream)


    def __init__(self, trend_data, stream, color_scheme):
        self.query = unquote(trend_data[QUERY_KEY].encode(ENCODING)).decode(ENCODING)

        super(Trend, self).__init__(escape(trend_data[TITLE_KEY]), stream, color_scheme)
